;==========================================================================================================
;==========================================================================================================
;==========================================================================================================
;								 ____					 _____	 _____
;				|     |	|	  | |	 \			|	  | |	  | |		|	  /
;				|	  |	|	  | |	  |			|	  | |	  | |		|	 /
;				|=====|	|	  |	|     |			|=====| |=====| |		|----
;				|	  |	|	  | |	  |			|	  | |	  | |		|	 \
;				|	  |	|_____| |____/			|	  | |	  | |_____	|	  \		- V. 2.5 -
;
;==========================================================================================================
;==========================================================================================================
;==========================================================================================================
;								+------------------------+
;								|	 BY BLACK FALCON	 |
;								+------------------------+
;
;==========================================================================================================
;==========================================================================================================


;I can't say my stuff is well organized. Alot of it is just hanging around somewhere.
;However I tried to comment everything for you so you know which routine does what
;also, after a while I couldn't think of any good branch names anymore, thus is why
;I'm using '+' signs sometimes.
;pretty much everything is written by me, except the button check to pause the game is taken from insom's code,
;because that's actually very clever made.
;there may as well be some other things copied, but those are only hijacks to prevent
;glitching and crashing, so there's no reason not to use them.

;NOTE:	this is a tweaked version of the HUD, removing any way to mix the beams! all the combos are pretty much useless now.
;		I simply removed the beam mixing part, but the RAM adresses are the same, so there
;		might be unused space in between those adresses, because normally the combos would go
;		in there.
;		(though you can still mix them in the status screen, but it won't have any effect)


;Known issues/bugs:

;		Issue:	Although hyper beam works with the HUD now, it doesn't flash in it's typical rainbow colors anymore (dunno why)	

;		Bug (*FIXED*):	When you press item select and run while the X-ray icon is selected, the codes conflict with each other, making
;						horrible graphic errors. The game doesn't crash and the errors don't stay forever, though.
;						(Note to myself: HEADDESK AND FIND A WAY TO CHECK FOR X-RAY IN THE PUBLIC RELEASE!)		

;		Issue (?FIXED?):	There may still be graphical errors sometimes when pressing select right after grappling/xraying/transitioning etc,
;							but I'm sure this happens due to engine limitations.

;	if you have any questions/ found any bugs/issues contact me.

;==========================================================================================================
;IMPORTANT NOTE:			To get this asm file to work properly in your ROM you need to patch CleanHUD.ips first before applying!
;==========================================================================================================
;	some additional notes:	
;							When pressing select, the HUD graphics are temporaily backup'd to 7F:FA02 - 7F:FB01 (0xFF bytes)
;							Be careful when using that space!

;							Yes, it is possible to add/remove weapons, but I'm too lazy to tell you what you have to do :P
;							you better figure that on your own.

;							Incase you found any typos/spelling errors you can keep them.
;							Incase you think the stuff I made is not inefficient enough, go ahead and make it even less efficient!

; 							Use this HUD patch on your own risk, backup frequently and only touch any of the labels/codes below if you know what you're doing!
; 							You are allowed to add/remove/modify as much things as you wish as long as you give credit to me when using it.
; 							I suggest reading carefully through the used RAM addresses, incase I forgot to list some of them.

; 							I think that's all you need to know. Have fun and Happy Hacking!

;							~BF

;=====================================================

;			--- LABELS ---

;=====================================================
{
;buttons:

!bitem = $09BA
!left = $09AE
!right = $09B0
!jump = $09B4
!cancel = $09B8
!up = $09AA
!down = $09AC

;equipment:

!colitems = $09A4

dash = $0CBF		;this small font table helped me alot
o = $280F
A = $0Cc0
B = $0Cc1
C = $0Cc2
D = $0Cc3
E = $0Cc4
F = $0Cc5
G = $0Cc6
H = $0Cc7
I = $0Cc8
J = $0Cc9
K = $0CcA
L = $0CcB
M = $0CcC
N = $0CcD
O = $0CcE
P = $0CcF
Q = $0CD0
R = $0CD1
S = $0CD2
T = $0CD3
U = $0CD4
V = $0CD5
W = $0CD6
X = $0CD7
Y = $0CD8
Z = $0CD9

;Beams:

!equbeams = $09A6
!colbeams = $09A8

;ammo weapons:

!missiles = $09C6
!maxmissiles = $09C8

!supers = $09CA
!maxsupers = $09CC

!powers = $09CE
!maxpowers = $09D0




!X = $1F5E					;current icon index, used by drawing routine to determine where to draw the icons
!F = $1F60					;flag, this is used to clear the HUD when switching between equipment and beams
!A = $1F62					;the tilemap data gets ANDed with this to set palette bits
  !green = #$D8FF			;values to put into !A
  !yellow = #$E0FF

!flag = $1F64

!missilenumber = $1F66	;how many equipment stuff collected (not only missiles, but I'n not going
							;to replace every reading from/writing to that address for no reason.)
!beamnumber = $1F68		;how many beams collected (charge doesn't count)
!beamicon = $1F6A			;only for graphics
!iconlist = $1F6C			;currently selected HUD item. independent from !icon
!rows = $1F6E

!beamlist = $1F70			;currently selected beam, independent from !equbeams
!beamarray = $1F72			;array for the collected beams, $A bytes iirc
!missilearray = $1F7C		;array for the collected equipment (not only missiles, lol)

!pausetime = $0A78			;already known the label says it all
!icon = $09D2				;same
!buttons = $8B

!sfxrowchange = #$0037		;click when switching between beam/equipment line
!sfxequ = #$0037				;click
!sfxbeam = #$0037				;click, iirc all of the sounds are using Library 2, not sure exactly...
!charge = $0CD0				;charge timer
}



;=====================================================

;			--- MISC. STUFF ---

;=====================================================
{
{
lorom


!state = #$0003				;Using Game State 3 (previously unused, put into $0998)

org $828987

DW STATE

org $82F720

STATE:		;had to make a new game state
	REP #$30 : PHP : STZ !pausetime
	LDA #$0008 : STA $0998
	LDA #$0010 : JSL $90F084 : JSR $8B44 : JSL $90EAAB
	PLP : RTS


;=====================================================


org $88E7CD		;hijack to stop certain FX, like bg HDMA, animations, etc.
	JSR $EE40	;acts exactly like state 1B (reserve tanks auto)
	REP 3 : NOP
	BCC $0E

org $88EE40
	LDA $0998 :	CMP #$001B : BEQ NOPes
				CMP !state : BEQ NOPes ;inserted a check for the new gamestate
		SEC : RTS
NOPes:	CLC : RTS
}
;=====================================================
{
;HUD NUMBER DISPLAY POSITIONS:

;when loading from save (once):
org $809B09	: LDX #$002C	;missiles
org $809B14 : LDX #$006E	;supers
org $809B25 : LDX #$00AE	;powers

;running part:
org $809C10 : LDX #$002C	;missiles
org $809C26 : LDX #$006E	;supers
org $809C4F : LDX #$00AE	;powers
}
;==========================================

;Auto Cancel cancel stuff, I know the NOPing part is useless, as I could've just thrown in RTSs,
;It's just to show which space is available, so it's up to you what you're doing with the available space
;I commented each skip. Those are run if you use the items when they are selected
{
org $809CA4	: REP 6 : NOP								;Kejardon, you forgot to skip this auto-cancel read in your CF patch! xP

org $888A97 : PLP : RTS : Padbyte $FF : pad $888AA2 	;auto-cancel check for x-ray, btw that PLP was responsible for some previous emulator crashes (well because it was not there lol...)
org $90BF20 : PLP : RTS : Padbyte $FF : pad $90BF46	;auto-cancel check for missiles
org $90C08C : PLP : RTS : Padbyte $FF : pad $90C0AB	;auto-cancel check for powerbombs
org $9BC8B9 : RTS : Padbyte $FF : pad $9BC8C4			;auto-cancel check for grapple
org $9BC9AE : RTS : Padbyte $FF : pad $9BC9B9			;auto-cancel check for grapple again
org $9BCA59 : Padbyte $EA : pad $9BC964				;auto-cancel check for grapple again
org $9BCBEF : RTS :									;auto-cancel check for grapple, hopefully the last read ;>_>

org $A9C4EB	: REP 3 : NOP ;STA $0A04
org $A9C518	: REP 3 : NOP ;STA $0A04
org $A9C53D	: REP 3 : NOP ;STA $0A04
}
;==========================================

;Misc. NOPs to disable code originally purposed to draw, switch/change icons, their colors, etc
;can't remember what handled what, though
{
org $809C69 : REP 9 : NOP
org $809C60	: REP 3 : NOP
org $809B31	: REP 3 : NOP
org $809B3A	: REP 3 : NOP
org $8489BD	: REP 4 : NOP
org $809C92	: REP 4 : NOP
}
;------------------------------------------

org $809B4E

JSR AUTO : REP 3 : NOP		;hint auto display when turning on HUD selection



{
; org $809B4E

; !energypos = #$008C 						;label that helped me placing things correctly in the HUD

	; LDA !pausetime	: BEQ $03 : JMP NODISPLAY ;skip if paused
	
; ENERGY:

	; LDA $09C2 : CMP $0A06					;Energy mirror
	; BEQ NODISPLAY : STA $0A06 : STA $4204
	; SEP #$20
	; LDA #$64 : STA $4206
	; PHA : PLA : PHA : PLA					;those PHA PLAs are used to give some time for the engine to calculate stuff
	; REP #$20
	; LDA $4214 : STA $14		;how many tanks in $14
	; LDA $4216 : STA $12		;how many energy bits in $12, hijacked current energy division
	; STA $18
	; LDA #$9DBF	: STA $00		;numbers
	; LDX !energypos : LDA $14
	; JSR $9D98					;draw tank number
	; LDX !energypos+4 : LDA $12
	; JSR $9D98					;four digit energy display complete!

; NODISPLAY:
; padbyte $EA : pad $809BFB

}



org $828063	
	JSL $809A79
org $828BA0
	JSL $809B44
org $8290F6
	JSL $809B44


;==================

org $809C00 : JSR Missile
org $809C3F : JSR Powers

{
org $80CDA0 
AUTO:
	LDA !pausetime : BNE MANUAL
	LDA $09C0 : CMP #$0001
MANUAL:
	RTS

Missile:

	LDA !maxmissiles : PHA : BEQ NOMI
	LDA !pausetime : BNE NOMI
	LDA #$34BA : PHA : LDA !icon : CMP #$0001 : BNE $05
	PLA : AND !green : PHA : PLA
	STA $7EC630 : INC a : STA $7EC632	;two tiles
NOMI:
	PLA : RTS

Supers:
	LDA !maxsupers : PHA : BEQ NOSU
	LDA !pausetime : BNE NOMI
	LDA #$34AC : PHA : LDA !icon : CMP #$0002 : BNE $05
	PLA : AND !green : PHA : PLA 
	STA $7EC670 : INC a : STA $7EC672	;two tiles
NOSU:
	PLA : RTS

Powers:
	LDA !maxpowers : PHA : BEQ NOPO
	LDA !pausetime : BNE NOMI
	LDA #$34AF : PHA : LDA !icon : CMP #$0003 : BNE $05
	PLA : AND !green : PHA : PLA
	STA $7EC6B0							;one tile
NOPO:
	PLA : RTS
}
;================================

org $8488B9 : JSR CHARGE : REP 6 : NOP	;LDA $0000,y : ORA $09A6 : STA $09A8
;-----------------------------------
org $84EFE0

CHARGE:
	LDA $12 : PHA : LDA $0000,y : CMP #$1000 : BNE NOPE
	STA $12 : LDA $09A6 : ORA $12 : STA $09A6
	LDA $09A8 : ORA $12 : STA $09A8
NOPE:
	PLA : STA $12 : RTS
;-----------------------------------
;org $90BF41 : REP 3 : NOP		;no turning off missiles/super missiles when ammo is empty
;org $90C0A6 : REP 3 : NOP		;^ same for Powers
;-----------------------------------
org $80948C : JSL FLAG			;leftover from Insom's code
;-----------------------------------
org $90B83C : JSL PAUSECHECK : NOP
;-----------------------------------
org $809A46 : PLY : PLX : PLP : RTS : REP 45 : NOP		;draw old hud icons,NOPing only to show that it's free for use, because there are no jumps calling that code anymore
;-----------------------------------
org $809A2E	: RTL	;various jumps called to draw the old HUD icons made obsolete
org $809A1E : RTL
org $809A0E : RTL
org $809A3E : RTL
;-----------------------------------
org $809B2B : JSR SWITCH : REP 15 : NOP				;LDA $09D2
org $809AB1 : JSR SWITCH : padbyte $EA : pad $809AE4 	;icons, initialisation
org $809C16	: JSR SWITCH								;this runs to switch between colors
;-----------------------------------
{
org $80D1C0

SWITCH:
	LDA !pausetime : BNE GOOUT
	PHX : PHY : JSL PARTONE
	LDA !missilenumber : BEQ PULLOUT
	CMP #$0001 : BNE $03
	STA !iconlist : LDA #$0020 : STA !X
	LDY #$FFFF : LDA !rows : BEQ $03
	LDY !green : STY !A
	LDA !iconlist : BEQ $07 : CMP #$0006 : BCS $02 : BRA Boop1
	LDA #$0001 : STA !iconlist
Boop1:
	ASL a : TAX : LDA !missilearray,x : JSL DRAWHUD

	;Part 1
	LDA #$0018 : STA !X : LDY #$FFFF : LDA !rows : BNE $03
	LDY !green : STY !A
BooP2:
	JSL CHECKs : CLC : ADC #$0006 : JSL DRAWHUD	
PULLOUT:
	PLY : PLX
GOOUT:
	JSR Supers : LDA $09CC : RTS
	}
;-----------------------------------
org $809CF5	: RTS : REP 3 : NOP ;part of old HUD draw routine
;-----------------------------------
org $90B810 : JSR RESET : STA $0DC2 : LDA $0A76 : BNE $08
}
;=====================================================
{

org $90C4BD								;this routine originally handled the selection of the HUD icons
										;second hijack point
	REP 28 : NOP
	JSL CHECKBUTTONS : BNE NEGATIVE
	JSR $90F084							;stops Samus' animations
	LDA $70	 : ORA #$7422 : STA $70 	;makes it darker
	LDA #$0005 : STA $0CD2	: STA $0CCE	;max out projectile and bomb counter
	JSR $F19B							;disable charge
;	LDA #$000A : JSL $80903F			;clear sounds
	BRA  POSITIVE
NEGATIVE:
	STZ $05F7	;enable automap
	REP 19 : NOP
POSITIVE:

}
;==========================================================================================================
;==========================================================================================================
;==========================================================================================================
;			  ___			   ___   ___   ___  _____
;	|\    /| |   | | |\  |	  |   | |   | |   |   |
;	| \  / | |___| | | \ |	  |___| |___| |___|   |
;	|  \/  | |   | | |  \|	  |     |   | |  \    |
;
;==========================================================================================================
;==========================================================================================================
;==========================================================================================================
{
org $90EAFA

	JSR UPDATE	;main hijack point
	

;======================

org $90FC00		;easier to repoint

RESET:
	LDA $09A6 : AND #$FF00 : JSL $90AC8D
ONE:
	LDA $0CD0 : RTS
UPDATE:
	JSL MAINBLOCK : RTS
NOCHARGE: 
	JSR $F19B : RTL ;disable charge, needs to be in bank $90
					;JSL from bank $DE

;=====================================================
{
org $DED940

LEGALITY:	;checks alot of things to prevent the game from crashing (I hate grapple beam for being glitchy!)

		LDA $0A1C	:	BNE +	:	BRA ++	;check elevator pose
+	:	CMP #$009B	:	BNE +	:	BRA ++	;same with big shoulders
+	:	CMP #$00B2	:	BNE +	:	BRA ++	;Grapple clockwise
+	:	CMP #$00B3	:	BNE +	:	BRA ++	;Grapple counterclockwise
+	:	CMP #$00B8	:	BNE +	:	BRA ++	;Attached to wall, left
+	:	CMP #$00B9	:	BNE +	:	BRA ++	;right
+	:	LDA $0CF6	:	BEQ +	:	BRA ++	;Check if grapple is fired
+	:	LDA $0A64	:	BEQ +	:	BRA ++	;grapple beam
+	:	LDA $0A1F	:	CMP #$0016	:	BNE +	:	BRA ++	;grapple beam movement
+	:	LDA $0A23	:	CMP #$0016	:	BNE +	:	BRA ++	;last frame
+	:	LDA $0CEE	:	BEQ +	:	BRA ++	;powerbomb timer
+	:	LDA $0A7E	:	BEQ +	:	BRA ++	;check if Game controls samus
+	:	LDA $0998	:	CMP #$0008	:	BEQ +	:	CMP !state	:	BEQ + ;check state
++	:	SEC	:	RTL							;don't do anything!
+	:	CLC	:	RTL							;you're good to go!
}
;=====================================================
{
MAINBLOCK:
	PHB	: PHX : PHY : JSL LEGALITY	: BCC +	: JMP END ;main check
+ : LDA $7FFF98	: BNE BUTTONCHECK : INC A : STA $7FFF98 : STA $7FFF9A ;this flag is set if you just pressed switch item. it's set to 0 if gfx update is required
;	-	status bar update:
	PHB : LDX #$FA02 : LDY #$C5C8 : LDA #$00FF : MVN $7F7E : PLB : JSR ENABLE	;put gfx into HUD and enable normal gameplay
	

BUTTONCHECK:
	JSL LEGALITY : BCC + : JMP END
+	
	JSL PARTONE								;checks which beams/equippment have been collected
	JSL PARTTWO								;determines row and button input
	JSL PARTTHREE							;puts beams where they belong

	LDA !buttons : AND !bitem : BEQ END
	LDA $8F : AND !bitem : BEQ JUMPS		;item select, when button is released
	


	PHB : LDY #$FA02 : LDX #$C5C8 : LDA #$00FF : MVN $7E7F 		;HUD backup, this backups EVERYTHING to 7FFA02!
	LDY #$C5C8	: LDX #PRESSED : LDA #$00FF : MVN $DE7E : PLB	;clear HUD

;deletes every >beam< projectile onscreen to prevent cheating and glitching
	LDX #$0000
DELETENEXT:		
	LDA $0C7C,x : BNE ITZAMISSILE : LDA $0C86,x : BNE ITZABOMB
	JSL $90ADB7
ITZABOMB:
ITZAMISSILE:
	INX : INX : CPX #$000A : BNE DELETENEXT
	JSL $82BE17	;clear sounds once

END:
	STZ !F : PLY : PLX : LDA $09C2 : PLB : RTL
JUMPS:
	JSL INSTRUCTIONS : BRA END


ENABLE:			;reset normal gameplay
	LDA #$0007 : STA $0741 : JSL $868000 : JSL $8483AD : JSL $878000 : JSL $8DC4C2 : JSL $82BE2F	;resume speed boost sound
	RTS

CHECKBUTTONS:

	JSL LEGALITY : BCC + : JMP QUIT
+	
	LDA !buttons : BIT !bitem : BEQ QUIT
	LDA $0A84 : BNE QUIT
	LDA #$8000 : STA !pausetime
	LDA !state	: STA $05F7	: STA $0998						;place new game state here, disable automap, set game state
	JSL $86800B : JSL $8483B8 : JSL $87800B : JSL $8DC4CD	;disables e/r projectiles, PLMS, animations, cascade fx
	LDA #$0000	: RTL										;0 makes the HUD pause the game 
QUIT:
	LDA #$FFFF : RTL										;unpause/prevent pausing
}
;=====================================================
{

DRAWhud:
	PHA : PHX : PHY : LDA !rows : BNE CHECKEQ
BEAMSC:
	JSR BEAMCHECK : LDA !beamnumber : BNE DRAWBEAMS
	LDA #$0018 : STA !X
	LDA #$FFFF : STA !A
	LDA #$0006 : BRA DRAWs
CHECKEQ:
	JSR EQUCHECK : LDA !missilenumber : BNE EQU : BRA BEAMSC
DRAWBEAMS:
	JSL CHECKs 
	LDA #$0018 : STA !X
	LDA #$FFFF : STA !A
	LDA !beamicon : CLC : ADC #$0006 : BRA DRAWs
EQU:
	LDA #$FFFF : STA !A
	LDA #$0020 : STA !X : LDA !iconlist : BEQ $07
	CMP #$0006 : BCS $02
	BRA + 
	LDA #$0001 : STA !iconlist
+
	ASL a : TAX : LDA !missilearray,x
DRAWs:
	JSL DRAWHUD : PLX : PLA : PLY : RTL
}	
;=====================================================
DRAWHUD: {
	;This routine draws all the 3x2 HUD icons 
			;label !X holds the positions, 
			;A holds which icon to use from the table
			;and the label !A holds the 'color filter'.
			;it ANDs the value to set either green or yellow palette bit
			;of course, it can also be #$FFFF, which means the icon
			;stays grey
	ASL a : ASL a : ASL a : ASL a : TAX

; x - -
; - - -
	PHX  
	LDA ICONS-16,x : AND !A : LDX !X : STA $7EC608,x		;!X holds position of icon to draw, !A the color palette
	PLX
	INX : INX

; o x -
; - - -
	PHX
	LDA ICONS-16,x : AND !A : LDX !X : STA $7EC60A,x
	PLX
	INX : INX

; o o x
; - - -
	PHX
	LDA ICONS-16,x : AND !A : LDX !X : STA $7EC60C,x
	PLX
	INX : INX
	
; o o o
; x - -
	PHX
	LDA ICONS-16,x : AND !A : LDX !X : STA $7EC648,x
	PLX
	INX : INX
; 0 0 0
; 0 x -
	PHX
	LDA ICONS-16,x : AND !A : LDX !X : STA $7EC64A,x
	PLX
	INX : INX

; 0 0 0
; 0 0 x
	PHX
	LDA ICONS-16,x : AND !A : LDX !X : STA $7EC64C,x
	PLX
	LDA #$FFFF : STA !A : RTL		;long because it's called outsite of bank $DE

CHECKs:
	LDA $0A76 : BEQ +
	LDA #$0004 : BRA ++
+
	LDA !beamlist : AND #$0007 : ASL a : TAX
	LDA !beamarray,x : ASL a : TAX
	LDA LIST,x
++
	STA !beamicon : RTL

LIST:		;Had to make this list to get the correct indices for each beam
	DW $0000
	DW $0001
	DW $0002
	DW $0000
	DW $0003
	DW $0000
	DW $0000
	DW $0000
	DW $0004

}
;=====================================================
INSTRUCTIONS: {

	JSR PARTFOUR	;icons
	JSR PARTFIVE	;names
	RTL
}
;=====================================================

;			--- PART ONE ---

;=====================================================
PARTONE: {

	PHX
	JSR EQUCHECK
	JSR BEAMCHECK
	PLX
	RTL

EQUCHECK:
	LDA #$0000 : LDX #$0000 : STA !missilenumber

AGAIN1:
	LDA #$0000 : STA !missilearray,x
	INX : INX : CPX #$000C : BNE AGAIN1

	LDX #$0002 : LDA !maxmissiles : BEQ SKIPM

	INC !missilenumber : LDA #$0001 : STA !missilearray,x
	INX : INX
SKIPM:
	LDA !maxsupers : BEQ SKIPS
	INC !missilenumber : LDA #$0002 : STA !missilearray,x
	INX : INX
SKIPS:
	LDA !maxpowers : BEQ SKIPP
	INC !missilenumber : LDA #$0003 : STA !missilearray,x 
	INX : INX
SKIPP:
	LDA !colitems : AND #$4000 : BEQ SKIPG
	INC !missilenumber : LDA #$0004 : STA !missilearray,x
	INX : INX
SKIPG:
	LDA !colitems : AND #$8000 : BEQ SKIPX
	INC !missilenumber : LDA #$0005 : STA !missilearray,x
SKIPX:
	LDA !rows : CMP #$5555 : BNE $07
	LDA #$0000 : STA !rows	: RTS

;---------------------

BEAMCHECK:


	LDA $0A76 : BEQ + 
	LDA #$0000 : STA !beamnumber : BRA SKIPPLA
+
	LDA #$0000 : LDX #$0000 : STA !beamnumber
AGAIN2:
	STA !beamarray,x
	INX : INX : CPX #$000C : BNE AGAIN2
	LDX #$0002 : LDA !colbeams : AND #$0001 : BEQ SKIPW
;SETWAVE:
	INC !beamnumber : STA !beamarray,x
	INX : INX
SKIPW:
	LDA !colbeams : AND #$0002 : BEQ SKIPICE
;SETICE:
	INC !beamnumber : STA !beamarray,x
	INX : INX
SKIPICE:
	LDA !colbeams : AND #$0004 : BEQ SKIPSP
;SETSP:
	INC !beamnumber : STA !beamarray,x
	INX : INX
SKIPSP:
	LDA !colbeams : AND #$0008 : BEQ SKIPPLA
;SETPLA:
	INC !beamnumber : STA !beamarray,x
SKIPPLA:
	RTS

;=====================================================

CHANGE:
	LDA !missilenumber : BEQ $03
	JMP SKIPCHECK2 : LDA #$0000 : STA !rows
	LDA !pausetime	: BNE $01 : RTL
	JMP BEAMROW
}
;=================================================================

;			--- PART TWO ---

;=====================================================
PARTTWO: {	

	LDA $8F : BIT !cancel : BNE CHANGE
	LDA !pausetime	: BNE $01 : RTL
	LDA $8F : BIT !up : BNE CHANGE
	BIT !down : BNE CHANGE
ROWCHECK:
	LDA !rows : BNE MISSILEROW
	JMP BEAMROW

;---------------------

MISSILEROW:
	LDA !missilenumber : BNE SKIPCHECK1 
	LDA #$0000 : STA !rows
	LDA #$0001 : STA !iconlist
	JMP BEAMROW

SKIPCHECK1:
	LDA !missilenumber : CMP #$0001 : BEQ NOCLICK
	LDA $8F : BIT !left : BNE LEFT1
	BIT !right : BNE RIGHT1
	LDA !iconlist : BEQ $07
	CMP #$0006 : BCS $02 : BRA Boop3
	LDA #$0001 : STA !iconlist
Boop3:
	BRA LEAVE1

RIGHT1:
	LDA !iconlist : CLC : ADC #$0001 : CMP !missilenumber : BMI STORE1 : BEQ STORE1
	LDA #$0001 : BRA STORE1
LEFT1:

	LDA !iconlist : SEC : SBC #$0001 : BNE STORE1
	LDA !missilenumber

STORE1:
	PHA
	LDA !sfxequ : JSL $809035
	PLA
NOCLICK:
	STA !iconlist
LEAVE1:
	RTL
;---------------------


SKIPCHECK2:
	LDA !rows : CLC : ADC #$0001 : AND #$0001 : STA !rows
	JSL NOCHARGE : LDA !sfxrowchange
	JSL $809035 : LDA !pausetime : BNE $01
	RTL
	JMP ROWCHECK
;---------------------


;The code below is not really effective due to uneeded RAM address abuse ;>_>
;Too lazy to fix. Of course, you could always try making it more efficient, but it's not my fault if you broke it :P

BEAMROW:
	LDA !beamnumber : BNE SOVER
	LDA #$0000 : STA !beamlist : RTL
SOVER:

	LDA $0A76 : BNE LEAVE2
	LDA $8F : BIT !left : BNE BLEFT : BIT !right : BNE BRIGHT ;: BIT !jump : BNE JUMP		;uncomment if you want to mix beams
	LDA !flag : CMP #$0077 : BEQ LEAVE2
	JSL CHECKs
	LDA !beamicon : STA !beamlist
	LDA #$0077 : STA !flag : RTL
	
BLEFT:
	LDA !beamlist : SEC : SBC #$0001 : BPL STORE2 : BEQ STORE2
	LDA !beamnumber : BRA STORE2
BRIGHT:
	LDA !beamlist : CLC : ADC #$0001 : CMP !beamnumber : BMI STORE2 : BEQ STORE2
	LDA #$0000
STORE2:
	STA !beamlist : LDA !sfxbeam : JSL $809035
LEAVE2:
	RTL
;:::::::::::::::::::::::::::::::::::::::::::	uncommend the following routine if you want to mix beams
	
;JUMP:
;	LDA !beamlist : BEQ MEEP : ASL a : TAX
;	LDA !beamarray,x 
;	PHA 
;	ASL a : TAX
;	LDA LIST,x : ASL a : TAX
;	LDA !marked,x : BEQ MARK
;	PLA
;	LDA #$0000 : STA !marked,x : DEC !marked
;MEEP:
;	LDA #$003E : JSL $8090A3 : RTL ;gives sound if not possible
;
;MARK:
;	PLA
;	STA !marked,x : INC !marked
;	LDA #$003A : JSL $8090A3			;click
;	LATER:
;	RTL

;:::::::::::::::::::::::::::::::::::::::::::
}
;=================================================================

;			--- PART THREE ---

;=====================================================

PARTTHREE: {


	LDA !rows : BNE MROW
	STZ !icon : LDA $0A76 : BNE GOTHYPER
NOHYPER:
	LDA !beamlist : CMP #$5555 : BNE BLA		;#$5555 is a defaut value for normally unused RAM space
	LDA #$0000 : STA !beamlist
BLA:
	LDA !beamlist : ASL a : TAX
	LDA !beamarray,x : STA $12
	LDA !equbeams : AND #$F000 : ORA $12 : STA !equbeams
GOTHYPER:
	RTL

MROW:
	LDA !iconlist : BEQ $07
	CMP #$0006 : BCS $02 : BRA STORE
	LDA #$0001 : STA !iconlist
STORE:
	ASL a : TAX : LDA !missilearray,x : STA !icon : RTL
	
;=====================================================
;-------- THE FOLLOWING CODE IS TAKEN FROM INSOM'S OLD PATCH (I've added some things, though)---------

FLAG:
	JSL LEGALITY : BCC + : BRA RETURN
+	
	LDA $7FFF9A	 : CMP #$0003 : BCS THREE ;timer, wait about 0x19 frames until you can fire again
	INC a : STA $7FFF9A : CMP #$0002 : BNE THREE
	STZ $0CD2 : STZ $0CCE

THREE:
	LDA $8B : AND $09BA : STA $06
	LDA $97 : AND $09BA : CMP $06 : BPL $05
	LDA #$FFFF : BRA FOUR : BEQ RETURN
	LDA #$0000
FOUR:
	STA $7FFF98	;flag, used to make sure to update HUD gfx

RETURN:
	LDA $8B : STA $97 : RTL

;=====================================================

PAUSECHECK:
	LDA !pausetime : BNE DELAY
	LDA $8B : AND $09B2 : RTL
DELAY:
	LDA #$0000 : RTL ;Disable shooting

;=====================================================

BEAMHOWMANY:

DW BEAM1
DW BEAM2
DW BEAM3
DW BEAM4
DW BEAM5

;---------------------

EQUHOWMANY:
DW ZEROROW
DW MISSILE1
DW MISSILE2
DW MISSILE3
DW MISSILE4
DW MISSILE5

ZEROROW:
	LDA #$0000 : STA !rows : RTS ;no equipment, yet
;---------------------

DRAWM:
	ASL a : TAX : LDA !missilearray,x : JSL DRAWHUD : RTS
DRAWB:
	ASL a : TAX : LDA $0A76 : BEQ +
	LDA #$000A : BRA ++
+
	LDA !beamarray,x : ASL a : TAX
	LDA LIST,x : CLC : ADC #$0006
++
	JSL DRAWHUD : RTS


;---------------------
}
;=================================================================

;			--- PART FOUR ---

;=====================================================
PARTFOUR: {


	LDA !rows : BEQ ROWBEAM
	
	LDA !F : CMP #$1111 : BEQ MSKIP ;to clear HUD again
	PHB
	LDY #$C5C8 : LDX #PRESSED : LDA #$00FF : MVN $DE7E
	PLB
	LDA #$1111 : STA !F
MSKIP:

	LDA !missilenumber : ASL a : TAX
	JSR (EQUHOWMANY,x) : RTS
;---------------------
ROWBEAM:
	LDA !F : CMP #$2222 : BEQ BSKIP ;if flag not set, redraw HUD
	PHB
	LDY #$C5C8 : LDX #PRESSED : LDA #$00FF : MVN $DE7E
	PLB
	LDA #$2222 : STA !F
BSKIP:
	LDA !iconlist : BEQ $07
	CMP #$0006 : BCS $02 : BRA Boop4
	LDA #$0001 : STA !iconlist
Boop4:
	LDA !beamnumber : ASL a : TAX
	JSR (BEAMHOWMANY,x) : RTS

;---------------------

MISSILE1:

	LDA #$0020 : STA !X
	LDA !green : STA !A ;LDA !yellow
	LDX #$0002 : LDA !missilearray,x
	JSL DRAWHUD : RTS

;---------------------

MISSILE2:

	LDA #$0020 : STA !X	;Part 1
	LDA !green : STA !A
	LDA !iconlist : JSR DRAWM
	LDA #$0028 : STA !X	;Part 2
	LDA !iconlist : CLC : ADC #$0001 : CMP !missilenumber : BMI MDRAW2 : BEQ MDRAW2
	LDA #$0001
MDRAW2:
	JSR DRAWM : RTS

;---------------------

MISSILE3:
	JSR MISSILE2			;take previous icon
	LDA #$0018 : STA !X
	LDA !iconlist : SEC : SBC #$0001 : BNE MDRAW3
	LDA !missilenumber
MDRAW3:	
	JSR DRAWM : RTS

;---------------------

MISSILE4:
	JSR MISSILE3			;take both previous icons
	LDA #$0030 : STA !X
	LDA !iconlist : CLC : ADC #$0001 : CMP !missilenumber	: BMI MDRAW40 : BEQ MDRAW41
	LDA #$0002 : BRA MDRAW4
MDRAW41:
	LDA #$0001 : BRA MDRAW4
MDRAW40:
	CLC : ADC #$0001
MDRAW4:
	JSR DRAWM : RTS

;---------------------

MISSILE5:
	JSR MISSILE4			;take the 3 previous icons
	LDA #$0010 : STA !X
	LDA !iconlist : SEC : SBC #$0001 : BNE MDRAW50
	LDA !missilenumber : SEC : SBC #$0001 : BRA MDRAW5
MDRAW51:
	LDA !missilenumber : BRA MDRAW5
MDRAW50:
	SEC : SBC #$0001 : BNE MDRAW5
	LDA !missilenumber
MDRAW5:
	JSR DRAWM : RTS


;---------------------

BEAM1:
	LDA #$0018 : STA !X
	LDA !green : STA !A
	LDX #$0000 : LDA $0A76 : BEQ POWERBEAMZ
	LDA #$000A : BRA HYPERBEAMZ
POWERBEAMZ:
	LDA !beamarray,x : CLC : ADC #$0006
HYPERBEAMZ:
	JSL DRAWHUD : RTS

;---------------------
BEAM2:
	LDA #$0018	: STA !X
	;LDA !yellow
	LDA !green : STA !A 
	LDA !beamlist : JSR DRAWB
	LDA #$0020 : STA !X
	LDA !beamlist : CLC : ADC #$0001 : CMP !beamnumber : BMI BDRAW2 : BEQ BDRAW2
	LDA #$0000
BDRAW2:
	JSR DRAWB
	RTS
;---------------------
BEAM3:
	JSR BEAM2 : LDA #$0010 : STA !X
	LDA !beamlist : SEC : SBC #$0001 : BPL BDRAW3 : BEQ BDRAW3 : LDA !beamnumber
BDRAW3:
	JSR DRAWB : RTS
;---------------------
BEAM4:
	JSR BEAM3 : LDA #$0028 : STA !X
	LDA !beamlist : CLC : ADC #$0001 : CMP !beamnumber : BMI BDRAW40 : BEQ BDRAW41
	LDA #$0001 : BRA BDRAW4
BDRAW41:
	LDA #$0000 : BRA BDRAW4
BDRAW40:
	CLC : ADC #$0001
BDRAW4:
	JSR DRAWB : RTS

;---------------------

BEAM5:
	JSR BEAM4 : LDA #$0008 : STA !X
	LDA !beamlist : SEC : SBC #$0001 : BEQ BDRAW51 : BPL BDRAW50
	LDA !beamnumber : SEC : SBC #$0001 : BRA BDRAW5
BDRAW51:
	LDA !beamnumber : BRA BDRAW5
BDRAW50:
	SEC : SBC #$0001
BDRAW5:
	JSR DRAWB : RTS

;---------------------
}
;=================================================================

;			--- PART FIVE ---

;=====================================================
PARTFIVE: {
	LDA !rows : BEQ BEAMNAMES
	LDA !icon : ASL a : TAX
	LDA NAMES-2,x : STA $14


DRAWNAMES:
	PHB
	LDX $14 : LDY #$C68E : LDA #$0032 : MVN $DE7E
	PLB
	RTS

BEAMNAMES:
	LDA $0A76 : BEQ NOHYPERNAME
	LDX #$0016 : BRA HYPERNAME
NOHYPERNAME:
	LDA !beamlist : ASL a : TAX
	LDA !beamarray,x : ASL a : TAX
	LDA LIST,x : CLC : ADC #$0006 : ASL a : TAX
HYPERNAME:
	LDA NAMES-2,x : STA $14 : BRA DRAWNAMES
}
;=====================================================


;           --- TILE TABLE PART ---
{
;the labels below helped me to get the right tile

h = $20AE	;horizontal tile
b = $209D	;blank
r = $209E	;end
e = $209C	;corner

rh = $60AE	;everything again, but flipped
rb = $609D
rr = $609E
re = $609C


PRESSED:

	DW h
	REP 30 : DW $280F 	;line 1
	DW rh

	DW h
	REP 30 : DW $280F 	;line 2
	DW rh

	DW h
	REP 30 : DW $280F 	;line 3
	DW rh


	DW e, b, b, b, b
	REP 22 : DW $280F ; blank, line 4
	DW b, b, b, b, re
	
	
ICONS:

	;DW $FFFF, $FFFF, $FFFF, $FFFF, $FFFF, $FFFF, $FFFF, $FFFF	;nothing
	DW $344B, $3449, $744B, $344C, $344A, $744C, $0000, $0000	;Missile
	DW $3434, $3435, $7434, $3436, $3437, $7436, $0000, $0000	;supers
	DW $3438, $3439, $7438, $343A, $343B, $743A, $0000, $0000	;powers
	DW $34a0, $34a1, $74a0, $34b0, $34b1, $74b0, $0000, $0000	;Grapple
	DW $34a4, $34a5, $74a4, $34b4, $34b5, $74b4, $0000, $0000	;Xray

;=====================================================

	DW $34a6, $34a7, $74a6, $34b6, $34b7, $74b6, $0000, $0000	;Power beam
	DW $34a2, $34a3, $74a2, $B4a2, $F4a3, $F4a2, $0000, $0000	;Wave beam
	DW $34b2, $34b3, $74b2, $B4b2, $B4b3, $F4b2, $0000, $0000	;ice beam
	DW $34aA, $34aB, $74aA, $B4aA, $B4ab, $F4aa, $0000, $0000	;Spazer
	DW $34a8, $34a9, $74a8, $34b8, $34b9, $74b8, $0000, $0000	;Plasma beam


NAMES:
	DW MISSILES
	DW SUPERS
	DW POWERS
	DW GRAPPLE
	DW XRAY

	DW POWER
	DW WAVE
	DW ICE
	DW SPAZER
	DW PLASMA
	DW HYPERN

	
MISSILES:

	DW b, b, b, b, b, b
	DW b, r, o, M, I, S, S, I, L, E, S, o, rr, b
	DW b, b, b, b, b, b

SUPERS:

	DW b, b, b, b, r, o
	DW S, U, P, E, R, o, M, I, S, S, I, L, E, S
	DW o, rr, b, b, b, b

POWERS:

	DW b, b, b, b, b, b
	DW r, o, P, O, W, E, R, o, B, O, M, B, S, o, rr, b
	DW b, b, b, b, b, b

GRAPPLE:

	DW b, b, b, b, b, r
	DW o, G, R, A, P, P, L, E, o, B, E, A, M, o
	DW rr, b, b, b, b, b

XRAY:

	DW b, b, b, b, b, b
	DW r, o, X, dash, R, A, Y, o, V, I, S, O, R, o, rr, b
	DW b, b, b, b, b, b

POWER:

	DW b, b, b, b, b, b
	DW r, o, P, O, W, E, R, o, B, E, A, M, o, rr
	DW b, b, b, b, b, b

WAVE:

	DW b, b, b, b, b, b
	DW r, o, W, A, V, E, o, B, E, A, M, o, rr, b
	DW b, b, b, b, b, b

ICE:

	DW b, b, b, b, b,	b
	DW b, r, o, I, C, E, o, B, E, A, M, o, rr, b
	DW b, b, b, b, b, b

SPAZER:

	DW b, b, b, b, b, b
	DW b, b, r, o, S, P, A, Z, E, R, o, rr, b, b
	DW b, b, b, b, b, b

PLASMA:

	DW b, b, b, b, b, b
	DW r, o, P, L, A, S, M, A, o, B, E, A, M, o, rr, b
	DW b, b, b, b, b, b

HYPERN:

	DW b, b, b, b, b, b
	DW r, o, H, Y, P, E, R, o, B, E, A, M, o, rr
	DW b, b, b, b, b, b#
}
}
;==========================================================================================================
	
	